
Inspect17 = {}; 
function Inspect17:loadMap(name) 
	local aNameSearch = {"vehicle.name." .. g_languageShort, "vehicle.name.en", "vehicle.name", "vehicle.storeData.name", "vehicle#type"};
	self.bDisplay = 1; 
	self.bLongFormat = 0; 
	self.nSubStringLength = 40; 
	self.bDarkColor = 0; 
	self.nDebugOutput = 0; 
	if Steerable.load ~= nil then 
		local orgSteerableLoad = Steerable.load 
		Steerable.load = function(self,xmlFile) 
			orgSteerableLoad(self,xmlFile) 
			for nIndex,sXMLPath in pairs(aNameSearch) do 
				self.name = getXMLString(self.xmlFile, sXMLPath); 
				if self.name ~= nil then 
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("UNKNOWN")
			end; 
		end;
	end;
end; 

function Inspect17:deleteMap() 

end; 

function Inspect17:mouseEvent(posX, posY, isDown, isUp, button)

end; 

function Inspect17:keyEvent(unicode, sym, modifier, isDown) 
	if isDown and sym == Input.KEY_up and bitAND(modifier, Input.MOD_CTRL) > 0 then 
		if self.bDisplay == 0 then 
			self.bDisplay = 1; 
		else self.bDisplay = 0; 
		end; 
	end; 
	if isDown and sym == Input.KEY_right and bitAND(modifier, Input.MOD_CTRL) > 0 then 
		if self.bLongFormat == 0 then 
			self.bLongFormat = 1; 
			self.nSubStringLength = 40; 
		else 
			self.bLongFormat = 0; 
			self.nSubStringLength = 25; 
		end; 
	end; 
	if isDown and sym == Input.KEY_left and bitAND(modifier, Input.MOD_CTRL) > 0 then
		if self.bDarkColor == 0 then 
			self.bDarkColor = 1; 
		else
			self.bDarkColor = 0; 
		end; 
	end; 
end; 

function Inspect17:update(dt) 

end; 

function Inspect17:draw() 
	if self.bDisplay == 0 then 
		return true; 
	end; 
	
	if g_currentMission.ingameMap.isFullSize == true then 
		return true; 
	end;
	
	if Input.keyPressedState[308] then 
		return true; 
	else 
		--local fPosX = 0.015; 
		--local fPosY = 0.92 - g_currentMission.helpBoxContentHeight;
		
		local fPosX = g_currentMission.helpBoxWidth + 0.03; 
		local fPosY = 0.979
		local fFontSize = 0.014; 
		local fLineDist = fFontSize + 0.002; 
		setTextAlignment(RenderText.ALIGN_LEFT); 
		local nLine = 0; 
		local nVehicles = table.getn(g_currentMission.steerables); 
		if nVehicles > 0 then 
			for i=1,nVehicles do 
				local oVehicle = g_currentMission.steerables[i]; 
				local sLineOutput = ""; 
				setTextBold(false); 
				if self.bDarkColor == 1 then 
					setTextColor(0,0,0,1); 
				else 
					setTextColor(1,1,1,1); 
				end; 
				if oVehicle.showWaterWarning then 
					sLineOutput = sLineOutput .. g_i18n:getText("filltype_water") .. "!!! "; 
				end; 
				if oVehicle.beaconLightsActive then 
					sLineOutput = sLineOutput .. "!"; 
				end; 
				if oVehicle.isHired then 
					sLineOutput = sLineOutput .. "*"; 
				end; 
				if sLineOutput ~= "" then 
					sLineOutput = sLineOutput .. " "; 
				end; 
				if oVehicle.isControlled then 
					if oVehicle.controllerName ~= nil then 
						sLineOutput = sLineOutput .. string.sub(Utils.getNoNil(oVehicle.controllerName, g_i18n:getText("UNKNOWN")), 0, 15) .. " / "; 
					end; 
					if g_currentMission.controlledVehicle == oVehicle then 
						setTextBold(true); 
					end; 
				end; 
				sLineOutput = sLineOutput .. string.sub(oVehicle.name, 0, self.nSubStringLength) .. " "; 
				local bVeryLowFuel = false; 
				if oVehicle.fuelFillLevel ~= nil then 
					local nFuelPercentage = oVehicle.fuelFillLevel / oVehicle.fuelCapacity * 100; 
					if nFuelPercentage < 10 then 
						sLineOutput = sLineOutput .. "@" .. round(nFuelPercentage) .. "% " .. g_i18n:getText("fillType_fuel") .. " "; 
						if nFuelPercentage <= 4 then 
							setTextColor(1,0,0,1); 
							bVeryLowFuel = true; 
						end; 
					end; 
				end; 
				
				local bAttachementHasFill = false; 
				 
				local bHasGrainInTank = false; 
				local fillLevelInformations = {};
				if oVehicle.getFillLevelInformation ~= nil then
				 	oVehicle:getFillLevelInformation(fillLevelInformations);
					for i,fillLevelInformation in pairs(fillLevelInformations) do
						if fillLevelInformation.fillLevel > 0 and fillLevelInformation.capacity > 0 then
							bHasGrainInTank = true;
							local nTankPercentage = getPercentage(fillLevelInformation.capacity, fillLevelInformation.fillLevel); 
							if (nTankPercentage > 0) then 
								local  fillTypeName = FillUtil.fillTypeIntToName[fillLevelInformation.fillType];
								local fillTypeName2 = fillTypeName
								fillTypeName = getFillType_new(fillLevelInformation.fillType, "")
								--sLineOutput = sLineOutput .. "| " .. fillLevelInformation.fillType .. "-" .. fillTypeName .. "(".. fillTypeName2 .. ")@" .. round(nTankPercentage) .. "% "; 
								sLineOutput = sLineOutput .. "| " .. fillTypeName .. "@" .. round(nTankPercentage) .. "% "; 
							end; 
							if nTankPercentage >= 80 then 
								setTextColor(1,1,0,1); 
							end; 
						end				
					end
				end;
				
				if bHasGrainInTank or oVehicle.isControlled or oVehicle.isHired or bAttachementHasFill or bVeryLowFuel then 
					nLine = nLine + 1; 
					renderText(fPosX, fPosY-(nLine*fLineDist), fFontSize, sLineOutput); 
				end; 
			end; 
		end; 
	end; 
end; 

function getFillType_new(fillType, implementTypeName)
	local sFillType = g_i18n:getText("UNKNOWN"); 
	
	if FillUtil.fillTypeIndexToDesc[fillType] ~= nil then
		output1 =  FillUtil.fillTypeIndexToDesc[fillType].nameI18N
		if string.find(output1, "Missing") then
			sFillType = g_i18n:getText("UNKNOWN"); 
		else
			sFillType = output1;
		end;
	end;
	
	return sFillType;
end; 

function round(num, idp) 
	if Utils.getNoNil(num, 0) > 0 then 
		local mult = 10^(idp or 0); 
		return math.floor(num * mult + 0.5) / mult; 
	else 
		return 0; 
	end; 
end; 

function getPercentage(capacity, level) 
	return level / capacity * 100; 
end;
 
addModEventListener(Inspect17);